USES Dos,
     GUtils, GMemory, GList, GErrors;


CONST
  FileName    = 'ALLFILES.TXT';
  BreakArea   = ' Ŀ';
  RotateChars : ARRAY[1..8] OF Char = ('-','\','|','/','-','\','|','/');
  BufSize     = 65000;


TYPE
  String80 = STRING[80];

  PBuffer  = ^TBuffer;
  TBuffer  = ARRAY[1..BufSize] OF Byte;

  PArea    = ^TArea;
  TArea    = OBJECT(TObject)
      Name : PString;
    Offset : LongInt;
    CONSTRUCTOR Init(AName:STRING; AOffset:LongInt);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PAreaList = ^TAreaList;
  TAreaList = OBJECT(TList)
    FUNCTION  __GetLine(ListPos:Integer): STRING; VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
  END;

  PFilesList = ^TFilesList;
  TFilesList = OBJECT(TBrowseList)
    FUNCTION  __GetLine(ListPos:Integer): STRING; VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
  END;

  PFilesCollection = ^TFilesCollection;
  TFilesCollection = OBJECT(TStringCollection)
    FUNCTION KeyOf(Item:Pointer): Pointer; VIRTUAL;
    FUNCTION Compare(Key1,Key2:Pointer): Integer; VIRTUAL;
  END;


VAR
  Areas     : PCollection;
  AreasList : PAreaList;
  Files     : PFilesCollection;
  FilesList : PFilesList;

  FilesCount: LongInt;
  FilesSizes: LongInt;



PROCEDURE Friday13_Logo; EXTERNAL; {$L ALLFILES\FR_LOGO.OBJ}




{---------------------------------------------------------------------------}
FUNCTION TFilesList.__GetLine(ListPos:Integer): STRING;
VAR Str:PString;
BEGIN
  Str := Files^.At(ListPos-1);
  __GetLine := GetStr(Str);
END;


PROCEDURE TFilesList.__HookListKeys(ListPos:Integer; VAR PressedKey:Word);
BEGIN
END;




{---------------------------------------------------------------------------}
PROCEDURE ReadFiles(AOffset:LongInt);
LABEL Exit;
CONST LineLen = 255;
VAR
  Index     : LongInt;
  Readen    : Word;
  Buffer    : PBuffer;
  DataFile  : FILE;
  CurrLine  : STRING;
  StrLength : Byte;

BEGIN
  Assign(DataFile,FileName);
  {$I-}
    Reset(DataFile,1);
    Seek(Datafile,AOffset);
  {$I+}
  IF IOResult <> 0 THEN ;

  New(Buffer);
  REPEAT
    BlockRead(DataFile,Buffer^,BufSize,Readen);

    Index := 0;
    REPEAT
      Move(Buffer^[Index],CurrLine,LineLen);
      CurrLine[0] := Chr(LineLen);
      StrLength   := Pos(#13#10,CurrLine);
      CurrLine[0] := Chr(StrLength);
      Inc(Index,StrLength+1);
      IF CurrLine[1] = #255 THEN Delete(CurrLine,1,1);
      Delete(CurrLine,Length(CurrLine),1);
      CurrLine := StripRight(CurrLine,' ');
      IF CurrLine = BreakArea THEN GOTO Exit;
      Files^.Insert( NewStr(CurrLine) );
    UNTIL Index >= Readen;
  UNTIL (CurrLine = BreakArea) OR (Readen <> SizeOf(Buffer^));
 Exit:
  Close(DataFile);
  Dispose(Buffer);
END;



PROCEDURE ShowFiles(Area:PArea);
VAR Index:Integer; PS:PString;
BEGIN
  New(Files, Init(1,1));
  Files^.Duplicates := True;
  ReadFiles(Area^.Offset);
  Files^.AtFree(Files^.Count-1);
  OpenWin(1,5,80,MaxY,$5D,$5B,Double1,StripBoth(Area^.Name^,' '));

  New(FilesList);
  WITH FilesList^ DO
  BEGIN
    Init(2,6,78,
         MaxY-6,
         Files^.Count,
         True,80,6,MaxY-1);
    Pallette[lBack] := $57;
    Pallette[lTopic] := $57;
    Pallette[lSelectedTopic] := $57;
    Pallette[lBar] := $57;
    Pallette[lSelectedBar] := $57;
    Pallette[lScroller] := $5D;
    Pallette[lFastFind] := $5D;

    Process;
  END;
  Dispose(FilesList,Done);
  RmWin;
  Dispose(Files, Done);
END;





{---------------------------------------------------------------------------}
CONSTRUCTOR TArea.Init(AName:STRING; AOffset:LongInt);
BEGIN
  Name := NewStr(AName);
  Offset := AOffset;
END;

DESTRUCTOR TArea.Done;
BEGIN
  DisposeStr(Name);
END;



{---------------------------------------------------------------------------}
FUNCTION TFilesCollection.KeyOf(Item:Pointer): Pointer;
BEGIN
  KeyOf := NIL;
END;

FUNCTION TFilesCollection.Compare(Key1,Key2:Pointer): Integer;
BEGIN
  Compare := -1;
END;




{---------------------------------------------------------------------------}
FUNCTION TAreaList.__GetLine(ListPos:Integer): STRING;
VAR Area:PArea;
BEGIN
  Area := Areas^.At(ListPos-1);
  __GetLine := ' '+Area^.Name^;
END;


PROCEDURE TAreaList.__HookListKeys(ListPos:Integer; VAR PressedKey:Word);
VAR Area:PArea;
BEGIN
  Area := Areas^.At(ListPos-1);
  CASE PressedKey OF
    kbEnter: ShowFiles(Area);
  END;
END;







{---------------------------------------------------------------------------}
PROCEDURE ReadAreas;
VAR F:Text; Buffer:PBuffer; Line: String80;
    AreaName:String80; Ps:Byte;
    Index:Byte;

BEGIN
  New(Buffer);
  Assign(F,FileName);
  SetTextBuf(F,Buffer^,SizeOf(Buffer^));
  {$I-}
    Reset(F);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    Dispose(Buffer);
    Writeln('ERROR: Can''t open '+FileName);
    Halt;
  END;

  New(Areas, Init(1,1));
  Index := 0;
  Write('Loading areas ');
  REPEAT
    ReadLn(F,Line);
    IF Line = BreakArea THEN
    BEGIN
      Inc(Index);
      IF Index = 9 THEN Index := 1;
      FastWrite(WhereX,WhereY,$7,RotateChars[Index]);
      ReadLn(F,AreaName);
      ReadLn(F,Line);
      AreaName := StripBoth(Copy(AreaName,12,57),' ');
      IF ExtractWords(1,1,AreaName) = 'Listed' THEN
      BEGIN
        Line := ExtractWords(2,1,AreaName);
        FilesCount := StrToInt(Line);
        Line := ExtractWords(4,1,AreaName);
        Line[0] := Chr ( Ord(Line[0])-1 );
        FilesSizes := StrToInt(Line);
        Break;
      END;
      AreaName := Copy(AreaName,6,255);
      Ps := Pos('-',AreaName);
      AreaName := Replicate(7-Ps,' ')+AreaName;
      Ps := Pos('-',AreaName);
      Insert('.',AreaName,Ps-1);
      Delete(AreaName,PS,2);
      Areas^.Insert( New(PArea, Init(AreaName, TextFilePos(F)) ));
    END;
  UNTIL Eof(F);
  ClearLine(WhereY,7);
  PosCursor(1,MaxY-2);
  Close(F);
  Dispose(Buffer);
END;




{---------------------------------------------------------------------------}
PROCEDURE Initialize;
BEGIN
  ClrScr(7);
  Cursor(Off);
  SetPal(AltPal);
  MkWin(10,1,61,2,$4C,Single1, '');
  WriteBetween(10,71,2,$4E,'Friday-13th BBS ALLFILES LISTER by The GodFather');
  OpenWin(12,5,57,MaxY-7,$19,$1B,Special2,'FILE AREAS');
  SmartHLine(12,68,MaxY-4,$19,SingleLine);
  WriteHi(15,MaxY-3,$17,$1A,'Total files: ~'+AddComas(FilesCount)+'~');
  WriteHi(42,MaxY-3,$17,$1A,'File sizes: ~'+AddComas(FilesSizes)+'~ Kb');

  New(AreasList);
  WITH AreasList^ DO
  BEGIN
    Init(13,6,56,MaxY-10,
         Areas^.Count,
         False,
         True,16,MaxY-4,#196,
         True,69,6,MaxY-5,
         lDefaultPal);
  END;
END;






{---------------------------------------------------------------------------}
BEGIN
  ReadAreas;

  Initialize;
  AreasList^.Process;
  Dispose(AreasList,Done);
  Dispose(Areas, Done);
  RmWin; RmWin;
  ClrScr(7);
  SetPal(OrgPal);
  PosCursor(1,MaxY-2);
  PartRestore(1,(MaxY DIV 2)-11,80,(MaxY DIV 2)+13, @Friday13_Logo^);
  Cursor(On);
END.